# Best Practices

## Coding Style Guide

We like to have a consistent coding style in the WordPress for iOS app, and to help us achieve this we’ve drafted a [style guide](coding-style-guide.md) outlining preferred code formatting, some preferred language idioms.

It’s a good idea to check the style guide from time to time as we update it to account for new improvements in the Objective-C language or in the iOS SDK.

## Follow Apple’s Human Interface Guidelines

Apple maintains an [iOS Human Interface Guidelines](https://developer.apple.com/design/human-interface-guidelines/ios/overview/themes/) document that “describes the guidelines and principles that help you design a superlative user interface and user experience for your iOS app.” Any new UI elements you create when contributing to the app should follow Apple’s guide.

## Follow WordPress Mobile’s Design Guidelines

We’ve set up a page that outlines the design philosophy for all WordPress Mobile Apps [here](https://make.wordpress.org/mobile/handbook/pathways/design/), make sure you read through it as well.

